/*
 * This file is part of gtkD.
 *
 * gtkD is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * gtkD is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with gtkD; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
// generated automatically - do not change
// find conversion definition on APILookup.txt
// implement new conversion functionalities on the wrap.utils pakage

/*
 * Conversion parameters:
 * inFile  = GUnixOutputStream.html
 * outPack = gio
 * outFile = UnixOutputStream
 * strct   = GUnixOutputStream
 * realStrct=
 * ctorStrct=GOutputStream
 * clss    = UnixOutputStream
 * interf  = 
 * class Code: No
 * interface Code: No
 * template for:
 * extend  = 
 * implements:
 * prefixes:
 * 	- g_unix_output_stream_
 * omit structs:
 * omit prefixes:
 * omit code:
 * omit signals:
 * imports:
 * structWrap:
 * module aliases:
 * local aliases:
 * overrides:
 */

module gio.UnixOutputStream;

public  import gtkc.giotypes;

private import gtkc.gio;
private import glib.ConstructionException;





private import gio.OutputStream;

/**
 * Description
 * GUnixOutputStream implements GOutputStream for writing to a
 * unix file descriptor, including asynchronous operations. The file
 * descriptor must be selectable, so it doesn't work with opened files.
 */
public class UnixOutputStream : OutputStream
{
	
	/** the main Gtk struct */
	protected GUnixOutputStream* gUnixOutputStream;
	
	
	public GUnixOutputStream* getUnixOutputStreamStruct()
	{
		return gUnixOutputStream;
	}
	
	
	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)gUnixOutputStream;
	}
	
	/**
	 * Sets our main struct and passes it to the parent class
	 */
	public this (GUnixOutputStream* gUnixOutputStream)
	{
		if(gUnixOutputStream is null)
		{
			this = null;
			return;
		}
		//Check if there already is a D object for this gtk struct
		void* ptr = getDObject(cast(GObject*)gUnixOutputStream);
		if( ptr !is null )
		{
			this = cast(UnixOutputStream)ptr;
			return;
		}
		super(cast(GOutputStream*)gUnixOutputStream);
		this.gUnixOutputStream = gUnixOutputStream;
	}
	
	/**
	 */
	
	/**
	 * Creates a new unix output stream for fd. If close_fd_at_close
	 * is TRUE, the fd will be closed when the output stream is destroyed.
	 * Params:
	 * fd =  unix's file descriptor.
	 * closeFdAtClose =  a gboolean.
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this (int fd, int closeFdAtClose)
	{
		// GOutputStream* g_unix_output_stream_new (int fd,  gboolean close_fd_at_close);
		auto p = g_unix_output_stream_new(fd, closeFdAtClose);
		if(p is null)
		{
			throw new ConstructionException("null returned by g_unix_output_stream_new(fd, closeFdAtClose)");
		}
		this(cast(GUnixOutputStream*) p);
	}
}
